/*

                           e Y8b    Y8b YV4.08P888 88e
                          d8b Y8b    Y8b Y888P 888 888D
                         d888b Y8b    Y8b Y8P  888 88"
                        d888WuHan8b    Y8b Y   888 b,
                       d8888888b Y8b    Y8P    888 88b,
           8888 8888       ,e,                                  888
           8888 888820088e  " Y8b Y888P ,e e, 888,8, dP"Y ,"Y88b888
           8888 8888888 88b888 Y8b Y8P d88 88b888 " C88b "8" 888888
           8888 8888888 888888  Y8b "  888   ,888    Y88D,ee 888888
           'Y88 88P'888 888888   Y8P    "YeeP"888   d,dP "88 888888
   888 88b,                    d8  888                     888
   888 88P' e88 88e  e88 88e  d88  888 e88 88e  ,"Y88b e88 888 ,e e, 888,8,
   888 8K  d888 888bd888 8Shaoziyang88d888 888b"8" 888d888 888d88 88b888 "
   888 88b,Y888 888PY888 888P 888  888Y888 888P,ee 888Y888 888888   ,888
   888 88P' "88 88"  "88 88"  888  888 "88 88" "88 888 "88 888 "YeeP"888


  Project:       AVR ͨ Bootloader
  File:          bootldr.c
                 
  Version:       4.2

  Compiler:      WinAVR 20071221 + AVR Studio 4.14.589

  Author:        Shaoziyang
                 Shaoziyang@gmail.com
                 http://avrubd.googlepages.com
                 http://groups.google.com/group/avrub?hl=en
                 
  Date:          2008.6

  鿴 readme.htm ø.

*/

#include "bootcfg.h"
#include "bootldr.h"

//ûʼ
#define PROG_START         0x0000

//ɾIVT
#define noIVT              0

//ջСС SPM_PAGESIZE
#if (BUFFERSIZE < SPM_PAGESIZE)
#define BUFSIZE SPM_PAGESIZE
#else
#define BUFSIZE BUFFERSIZE
#endif

//ջ
unsigned char buf[BUFSIZE];

#if (BUFSIZE > 255)
unsigned int bufptr, pagptr;
#else
unsigned char bufptr, pagptr;
#endif

unsigned char ch, cl;

//ǰFlashַָ
#if (FLASHEND > 0xFFFFUL)
unsigned long int FlashAddr;
#else
unsigned int FlashAddr;
#endif

//ӳļ
#if Decrypt

//PC1 㷨ӳ
#if (Algorithm == PC1_128)||(Algorithm == PC1_256)
#include "pc1crypt.c"
#elif (Algorithm == AES_128)||(Algorithm == AES_256)
#include "aes.c"
#else
#error "Unknow encrypt algorithm!"
#endif

#endif  //Decrypt


//һFlashҳ
void write_one_page(unsigned char *buf)
{
  boot_page_erase(FlashAddr);                  //һFlashҳ
  boot_spm_busy_wait();
  for(pagptr = 0; pagptr < SPM_PAGESIZE; pagptr += 2) //Flashҳ
  {
    boot_page_fill(pagptr, buf[pagptr] | (buf[pagptr + 1] << 8));
  }
  boot_page_write(FlashAddr);                  //ҳдһFlashҳ
  boot_spm_busy_wait();                        //ȴҳ
}

//תû
void quit()
{
#if Decrypt
    DestroyKey();                              //Կ
#endif

  boot_rww_enable();                           //ûд
  (*((void(*)(void))PROG_START))();            //ת'jmp 0'ʡռ
}

//дݵ
void WriteCom(unsigned char dat)
{
#if RS485
  RS485Enable();
#endif

  UDRREG(COMPORTNo) = dat;
  //ȴݷ
  while(!(UCSRAREG(COMPORTNo) & (1<<TXCBIT(COMPORTNo))));
  UCSRAREG(COMPORTNo) |= (1 << TXCBIT(COMPORTNo));

#if RS485
  RS485Disable();
#endif
}

//ȴ
unsigned char WaitCom()
{
  while(!DataInCom());
  return ReadCom();
}

#if VERBOSE
//ַӻس
void putstr(const char *str)
{
  while(*str)
    WriteCom(*str++);

  WriteCom(0x0D);
  WriteCom(0x0A);
}
#endif

//CRCУ飺1021
void crc16(unsigned char *buf)
{
#if (BUFSIZE > 255)
  unsigned int j;
#else
  unsigned char j;
#endif

#if (CRCMODE == 0)
  unsigned char i;
  unsigned int t;
#endif
  unsigned int crc;

  crc = 0;
  for(j = BUFFERSIZE; j > 0; j--)
  {
#if (CRCMODE == 0)
    //׼CRCУ
    crc = (crc ^ (((unsigned int) *buf) << 8));
    for(i = 8; i > 0; i--)
    {
      t = crc << 1;
      if(crc & 0x8000)
        t = t ^ 0x1021;
      crc = t;
    }
#elif (CRCMODE == 1)
    //ۼӺУ
    crc += (unsigned int)(*buf);
#elif

#endif
    buf++;
  }
  ch = crc / 256;
  cl = crc % 256;
}

//Ҫɾж(interrupt vect table),  noIVT Ϊ 1
//ѡ "-nostartfiles" ѡ
//ɾж
#if noIVT
void initstack(void) __attribute__ ((section(".init9")));
void initstack(void) 
{
  //öջ
  asm volatile ( ".set __stack, %0" :: "i" (RAMEND) ); 
  //ת
  asm volatile ( "rjmp main");
}
#endif

//
int main(void)
{
  unsigned char cnt;
  unsigned char packNO;
  unsigned char crch, crcl;

#if (InitDelay > 0)
#if (InitDelay > 255)
  unsigned int di;
#elif InitDelay
  unsigned char di;
#endif
#endif

#if (BUFFERSIZE > 255)
  unsigned int li;
#else
  unsigned char li;
#endif

  //رжϣ쳣µı
  cli();

#if WDG_En
  //ŹÿŹʱʱ
  wdt_enable(WDTO_1S);
#else
  //ֹŹ
#ifndef MCUSR
#define MCUSR    MCUCSR
#endif
  MCUSR = 0;
  wdt_disable();
#endif

  //ʱӳʼ:CTCģʽ
  TimerInit();

#if RS485
  //ʼ RS485 ˿
  DDRREG(RS485PORT) |= (1 << RS485TXEn);
  RS485Disable();
#endif

#if LED_En
  //LED˿Ϊ״̬
  DDRREG(LEDPORT) |= (1 << LEDPORTNo);
#endif

  //ڳʼ
  ComInit();

#if InitDelay > 0
  //ĳЩͺŵĵƬҪʱ
  for(di = InitDelay; di > 0; di--)
    __asm__ __volatile__ ("nop": : );
#endif

#if LEVELMODE
  //ŵƽBootloaderģʽ
  //ö˿Ϊ״̬
  DDRREG(LEVELPORT) &= ~(1 << LEVELPIN);
#if PINLEVEL
  if(PINREG(LEVELPORT) & (1 << LEVELPIN))
#else
  if(!(PINREG(LEVELPORT) & (1 << LEVELPIN)))
#endif
  {
#if VERBOSE
    //ʾģʽ
    putstr(msg6);
#endif
  }
  else
  {
#if VERBOSE
    //ʾû
    putstr(msg7);
#endif

    quit();
  }

#else
  //Bootloaderģʽ

#if VERBOSE
  //ʾȴ
  putstr(msg1);
#endif

  cnt = TimeOutCnt;
  cl = 0;
  while(1)
  {
#if WDG_En
    //Ź
    wdt_reset();
#endif

    if(TIFRREG & (1<<OCF1A))    //T1
    {
      TIFRREG |= (1 << OCF1A);

      if(cl == CONNECTCNT)      //ж
        break;

#if LED_En
      LEDAlt();                 //LEDָʾ״̬
#endif

      cnt--;
      if(cnt == 0)              //ӳʱ
      {

#if VERBOSE
        putstr(msg2);           //ʾʱ
#endif
        quit();                 //˳bootloader
      }
    }

    if(DataInCom())             //յ
    {
      if(ReadCom() == ConnectKey[cl])  //Ƚ
        cl++;
      else
        cl = 0;
    }
  }

#endif  //LEVELMODE

#if VERBOSE
  putstr(msg3);                 //ʾȴļ
#endif

#if Decrypt
  DecryptInit();
#endif

  //ÿʱ϶PCһַCȴ֡soh
  cnt = TimeOutCntC;
  while(1)
  {
    if(TIFRREG & (1 << OCF1A))  //T1
    {
      TIFRREG |= (1 << OCF1A);
      WriteCom(XMODEM_RWC) ;    // "C"

#if LED_En
      LEDAlt();                 //LEDָʾ״̬
#endif

      cnt--;
      if(cnt == 0)              //ʱ
      {
#if VERBOSE
        putstr(msg2);           //ʾʱ
#endif
        quit();                 //˳ bootloader
      }
    }

#if WDG_En
    wdt_reset();                //Ź
#endif

    if(DataInCom())
    {
      if(ReadCom() == XMODEM_SOH)  //XMODEMʼ
        break;
    }
  }

  TCCR1B = 0;                   //رնʱ1

  //ʼ
  packNO = 0;
  bufptr = 0;
  cnt = 0;
  FlashAddr = 0;
  do
  {
    packNO++;
    ch =  WaitCom();                          //ȡ
    cl = ~WaitCom();
    if ((packNO == ch) && (packNO == cl))
    {
      for(li = BUFFERSIZE; li > 0; li--)      //һ֡
      {
        buf[bufptr++] = WaitCom();
      }
      crch = WaitCom();                       //ȡУֽ
      crcl = WaitCom();
      crc16(&buf[bufptr - BUFFERSIZE]);       //У
      if((crch == ch) && (crcl == cl))
      {
#if BootStart
        if(FlashAddr < BootStart)             //дBoot
        {
#endif

#if Decrypt
          DecryptBlock(&buf[bufptr - BUFFERSIZE], BUFFERSIZE); //ܻ
#endif

#if BUFFERSIZE <= SPM_PAGESIZE
          if(bufptr >= SPM_PAGESIZE)          //дݣ
          {                                   //ն֡дһҳ
            write_one_page(buf);              //д뻺ݵFlash
            FlashAddr += SPM_PAGESIZE;        //޸Flashҳַ
            bufptr = 0;
          }
#else
          while(bufptr > 0)                   //һ֡дҳ
          {
            write_one_page(&buf[BUFSIZE - bufptr]);
            FlashAddr += SPM_PAGESIZE;        //޸Flashҳַ
            bufptr -= SPM_PAGESIZE;
          }
#endif

#if BootStart
        }
        else                                  //BootStartΧд
        {
          bufptr = 0;                         //ýָ
        }
#endif

//ȡдFlashݲͻȽ
#if (ChipCheck > 0) && (BootStart > 0)
#if (BUFFERSIZE < SPM_PAGESIZE)
        if((bufptr == 0) && (FlashAddr < BootStart))
#else
        if(FlashAddr < BootStart)
#endif
        {
          boot_rww_enable();                  //û
          cl = 1;                             //־λ
          for(pagptr = 0; pagptr < BUFSIZE; pagptr++)
          {
#if (FLASHEND > 0xFFFFUL)
            if(pgm_read_byte_far(FlashAddr - BUFSIZE + pagptr) != buf[pagptr])
#else
            if(pgm_read_byte(FlashAddr - BUFSIZE + pagptr) != buf[pagptr])
#endif
            {
              cl = 0;                         //ô־λ
              break;
            }
          }
          if(cl)                              //Уȷ
          {
            WriteCom(XMODEM_ACK);
            cnt = 0;
          }
          else
          {
            WriteCom(XMODEM_NAK);             //Уط
            cnt++;                            //1
            FlashAddr -= BUFSIZE;             //FlashAddrַ
          }
        }
        else                                  //УBootֱӷȷӦ
        {
          WriteCom(XMODEM_ACK);
          cnt = 0;
        }
#else
        WriteCom(XMODEM_ACK);                 //У飬ֱӷȷӦ
        cnt = 0;
#endif

#if WDG_En
        wdt_reset();                          //Ź
#endif

#if LED_En
        LEDAlt();                             //LED ָʾ״̬
#endif
      }
      else //CRC
      {
        WriteCom(XMODEM_NAK);                 //Ҫط
        cnt++;
      }
    }
    else //PackNo
    {
      WriteCom(XMODEM_NAK);                   //Ҫط
      cnt++;
    }

    if(cnt > 3)                               //ֹ̫࣬
      break;
  }
  while(WaitCom() != XMODEM_EOT);
  WriteCom(XMODEM_ACK);


#if VERBOSE
  if(cnt == 0)
  {
    //ɹ
    putstr(msg4);                             //ʾɹ
  }
  else
  {
    //ʧ
    putstr(msg5);                             //ʾʧ

#if WDG_En
    while(1);                                 //ȴŹλ
#else
#if (BootStart > 0)
    (*((void(*)(void))(BootStart)))();        //ת bootloader
#endif
#endif
  }

#else

  if(cnt > 0)
#if WDG_En
    while(1);                                 //ʧܣȴŹλ
#else    
#if (BootStart > 0)
    (*((void(*)(void))(BootStart)))();
#endif
#endif

#endif

  quit();                                     //˳bootloader
  return 0;
}

//End of file: bootldr.c
